package fachada;

import produtos.*;

public class Estoque {
	
    private CadastroProdutos produtos;
    
    public Estoque(RepositorioProdutos repositorioProdutos) {
        this.produtos = new CadastroProdutos(repositorioProdutos);
    }
    
    public void cadastrar(Produto produto) throws ProdutoJaCadastradoException, RepositorioException {
        produtos.cadastrar(produto);
    }
    
    public void atualizar(Produto produto) throws ProdutoNaoEncontradoException, RepositorioException {
        produtos.atualizar(produto);
    }
        
    public Produto procurar(int codigo) throws ProdutoNaoEncontradoException, RepositorioException {
        return produtos.procurar(codigo);
    }
    
    public boolean existe(int codigo) throws RepositorioException {
        return produtos.existe(codigo);
    }
    
    public void remover(int codigo) throws ProdutoNaoEncontradoException, RepositorioException {
        produtos.remover(codigo);
    }
    
}
