package gui;

import produtos.*;
import fachada.Estoque;
import util.Util;

public class Programa {
	
	private static Estoque estoque;

	public static void main(String[] args) {
		// declarando variaveis auxiliares
		String nome = null;
		double preco = 0;
		int quantidade = 0;
		int codigo = 0;
		Produto produto = null;

		RepositorioProdutos repositorio = null;
		System.out.println("Digite 1 para usar o sistema com array e 2 para usar com banco de dados.");
		int opcao = Util.readInt();
		if (opcao == 1) {
			repositorio = new RepositorioProdutosArray();
		} else {
			//repositorio = new RepositorioProdutosBDR();
		}		
		estoque = new Estoque(repositorio);

		opcao = 1;
		while (opcao != 0) {
			try {
				System.out.println("Aperte <Enter> para continuar");
				Util.waitEnter();
				System.out.println("\n\n\n\n\n\n\n");
				// imprimindo o menu
				System.out.println("Escolha uma das opes abaixo:");
				System.out.println("1 - Cadastrar produto");
				System.out.println("2 - Adicionar produto em estoque");
				System.out.println("3 - Diminuir produto em estoque");
				System.out.println("4 - Alterar preo");
				System.out.println("5 - Consultar produto");
				System.out.println("6 - Remover");
				System.out.println("0 - Sair");
				// lendo a opo
				opcao = Util.readInt();

				switch (opcao) {

					case 1 :
						System.out.print("Nome:");
						nome = Util.readStr();
						System.out.print("Cdigo:");
						codigo = Util.readInt();
						System.out.print("Preco:");
						preco = Util.readDbl();
						System.out.print("Quantidade:");
						quantidade = Util.readInt();
						produto = new Produto(codigo, nome, preco, quantidade);
						estoque.cadastrar(produto);
						System.out.println("\nProduto cadastrado com sucesso");
						break;

					case 2 :
						produto = getProduto();
						System.out.print("Quantidade de "+produto.getNome()+" a adicionar:");
						quantidade = Util.readInt();
						produto.adicionar(quantidade);
						estoque.atualizar(produto);
						System.out.println("\nAdio efetivada com sucesso");
						break;

					case 3 :
						produto = getProduto();
						System.out.print("Quantidade de "+produto.getNome()+" a diminuir:");
						quantidade = Util.readInt();
						produto.diminuir(quantidade);
						estoque.atualizar(produto);
						System.out.println("\nOperao efetivada com sucesso");
						break;

					case 4 :
						produto = getProduto();
						System.out.print("Informe o novo preo do produto "+produto.getNome()+" :");
						preco = Util.readDbl();
						produto.setPreco(preco);
						estoque.atualizar(produto);
						System.out.println("\nPreo atualizado com sucesso");
						break;

					case 5 :
						produto = getProduto();
						System.out.println("");						
						System.out.println("Nome:       " + produto.getNome());
						System.out.println("Cdigo:     " + produto.getCodigo());
						System.out.println("Preo:      " + produto.getPreco());
						System.out.println("Quantidade: " + produto.getQuantidade());
						break;

					case 6 :
						System.out.print("Informe o cdigo do produto:");
						codigo = Util.readInt();
						estoque.remover(codigo);
						System.out.println("\nProduto removido com sucesso.");
						break;

					case 0 :
						System.out.println("Saindo...");
						break;

					default :
						System.out.println("Opo Incorreta! Escolha uma das opes do menu!\n");
						break;
				}
				System.out.println("\n");
			} catch (Exception exception) {
				System.out.println("\n");
				System.out.println(exception.getMessage().toUpperCase());
				System.out.println("\n");				
			}
		}
	}

	public static Produto getProduto() throws ProdutoNaoEncontradoException, RepositorioException {
		System.out.print("Informe o cdigo do produto:");
		int codigo = Util.readInt();
		return estoque.procurar(codigo);
	}

}