package produtos;

public class CadastroProdutos {
	
    private RepositorioProdutos produtos;
    
    public CadastroProdutos(RepositorioProdutos produtos) {
        this.produtos = produtos;
    }
    
    public void cadastrar(Produto produto) throws ProdutoJaCadastradoException, RepositorioException {
        if (produtos.existe(produto.getCodigo())) {
            throw new ProdutoJaCadastradoException();
        } else {
            produtos.inserir(produto);
        }
    }
    
    public void atualizar(Produto produto) throws ProdutoNaoEncontradoException, RepositorioException {
        produtos.atualizar(produto);
    }
        
    public Produto procurar(int codigo) throws ProdutoNaoEncontradoException, RepositorioException {
        return produtos.procurar(codigo);
    }
    
    public void remover(int codigo) throws ProdutoNaoEncontradoException, RepositorioException {
        produtos.remover(codigo);
    }
    
    public boolean existe(int codigo) throws RepositorioException {
        return produtos.existe(codigo);
    }
    
}
