package produtos;

public class RepositorioProdutosArray implements RepositorioProdutos {

	private Produto[] produtos;
	private int indice;

	public RepositorioProdutosArray() {
		produtos = new Produto[100];
		indice = 0;
	}

	public void inserir(Produto produto) {
		produtos[indice] = produto;
		indice = indice + 1;
	}

	public void atualizar(Produto produto) throws ProdutoNaoEncontradoException {
		int i = getIndice(produto.getCodigo());
		if (i == indice) {
			throw new ProdutoNaoEncontradoException();
		} else {
			produtos[i] = produto;
		}
	}

	public void remover(int codigo) throws ProdutoNaoEncontradoException {
		int i = getIndice(codigo);
		if (i == indice) {
			throw new ProdutoNaoEncontradoException();
		} else {
			produtos[i] = produtos[indice - 1];
			indice = indice - 1;
		}
	}

	public Produto procurar(int codigo) throws ProdutoNaoEncontradoException {
		Produto resposta;
		int i = getIndice(codigo);
		if (i == indice) {
			throw new ProdutoNaoEncontradoException();
		} else {
			resposta = produtos[i];
		}
		return resposta;
	}

	public boolean existe(int codigo) {
		boolean resposta;
		int i = getIndice(codigo);
		if (i == indice) {
			resposta = false;
		} else {
			resposta = true;
		}
		return resposta;
	}

	private int getIndice(int codigo) {
		int n;
		boolean achou = false;
		int i = 0;
		while ((!achou) && (i < indice)) {
			n = produtos[i].getCodigo();
			if (n == codigo) {
				achou = true;
			} else {
				i = i + 1;
			}
		}
		return i;
	}

}